t / test-lib.shon commit fsck-objects: work from subdirectory. (61e2b01)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# For repeatability, reset the environment to known value.
   7LANG=C
   8LC_ALL=C
   9PAGER=cat
  10TZ=UTC
  11export LANG LC_ALL PAGER TZ
  12unset AUTHOR_DATE
  13unset AUTHOR_EMAIL
  14unset AUTHOR_NAME
  15unset COMMIT_AUTHOR_EMAIL
  16unset COMMIT_AUTHOR_NAME
  17unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  18unset GIT_AUTHOR_DATE
  19unset GIT_AUTHOR_EMAIL
  20unset GIT_AUTHOR_NAME
  21unset GIT_COMMITTER_EMAIL
  22unset GIT_COMMITTER_NAME
  23unset GIT_DIFF_OPTS
  24unset GIT_DIR
  25unset GIT_EXTERNAL_DIFF
  26unset GIT_INDEX_FILE
  27unset GIT_OBJECT_DIRECTORY
  28unset SHA1_FILE_DIRECTORIES
  29unset SHA1_FILE_DIRECTORY
  30
  31# Each test should start with something like this, after copyright notices:
  32#
  33# test_description='Description of this test...
  34# This test checks if command xyzzy does the right thing...
  35# '
  36# . ./test-lib.sh
  37
  38error () {
  39        echo "* error: $*"
  40        trap - exit
  41        exit 1
  42}
  43
  44say () {
  45        echo "* $*"
  46}
  47
  48test "${test_description}" != "" ||
  49error "Test script did not set test_description."
  50
  51while test "$#" -ne 0
  52do
  53        case "$1" in
  54        -d|--d|--de|--deb|--debu|--debug)
  55                debug=t; shift ;;
  56        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  57                immediate=t; shift ;;
  58        -h|--h|--he|--hel|--help)
  59                echo "$test_description"
  60                exit 0 ;;
  61        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  62                verbose=t; shift ;;
  63        *)
  64                break ;;
  65        esac
  66done
  67
  68exec 5>&1
  69if test "$verbose" = "t"
  70then
  71        exec 4>&2 3>&1
  72else
  73        exec 4>/dev/null 3>/dev/null
  74fi
  75
  76test_failure=0
  77test_count=0
  78
  79trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
  80
  81
  82# You are not expected to call test_ok_ and test_failure_ directly, use
  83# the text_expect_* functions instead.
  84
  85test_ok_ () {
  86        test_count=$(expr "$test_count" + 1)
  87        say "  ok $test_count: $@"
  88}
  89
  90test_failure_ () {
  91        test_count=$(expr "$test_count" + 1)
  92        test_failure=$(expr "$test_failure" + 1);
  93        say "FAIL $test_count: $1"
  94        shift
  95        echo "$@" | sed -e 's/^/        /'
  96        test "$immediate" = "" || { trap - exit; exit 1; }
  97}
  98
  99
 100test_debug () {
 101        test "$debug" = "" || eval "$1"
 102}
 103
 104test_run_ () {
 105        eval >&3 2>&4 "$1"
 106        eval_ret="$?"
 107        return 0
 108}
 109
 110test_expect_failure () {
 111        test "$#" = 2 ||
 112        error "bug in the test script: not 2 parameters to test-expect-failure"
 113        say >&3 "expecting failure: $2"
 114        test_run_ "$2"
 115        if [ "$?" = 0 -a "$eval_ret" != 0 ]
 116        then
 117                test_ok_ "$1"
 118        else
 119                test_failure_ "$@"
 120        fi
 121}
 122
 123test_expect_success () {
 124        test "$#" = 2 ||
 125        error "bug in the test script: not 2 parameters to test-expect-success"
 126        say >&3 "expecting success: $2"
 127        test_run_ "$2"
 128        if [ "$?" = 0 -a "$eval_ret" = 0 ]
 129        then
 130                test_ok_ "$1"
 131        else
 132                test_failure_ "$@"
 133        fi
 134}
 135
 136test_done () {
 137        trap - exit
 138        case "$test_failure" in
 139        0)      
 140                # We could:
 141                # cd .. && rm -fr trash
 142                # but that means we forbid any tests that use their own
 143                # subdirectory from calling test_done without coming back
 144                # to where they started from.
 145                # The Makefile provided will clean this test area so
 146                # we will leave things as they are.
 147
 148                say "passed all $test_count test(s)"
 149                exit 0 ;;
 150
 151        *)
 152                say "failed $test_failure among $test_count test(s)"
 153                exit 1 ;;
 154
 155        esac
 156}
 157
 158# Test the binaries we have just built.  The tests are kept in
 159# t/ subdirectory and are run in trash subdirectory.
 160PATH=$(pwd)/..:$PATH
 161GIT_EXEC_PATH=$(pwd)/..
 162export GIT_EXEC_PATH
 163
 164# Test repository
 165test=trash
 166rm -fr "$test"
 167mkdir "$test"
 168cd "$test"
 169git-init-db --template=../../templates/blt/ 2>/dev/null ||
 170error "cannot run git-init-db"
 171
 172mv .git/hooks .git/hooks-disabled
 173